searchNodes=[{"doc":"A Rustler NIF that interfaces with JACK. Use ExJack.Server instead. While there are only minimal number of functions compared to the JACK API, the majority of interfacing is done through messages sent between the NIF thread and ExJack.Server GenServer process. Typically when interfacing with ExJack, calling these methods directly isn't necessary and you should instead, as a client, use ExJack.Server . If you are interested in using this library, signatures and usage can be found in ExJack.Server .","ref":"ExJack.Native.html","title":"ExJack.Native","type":"module"},{"doc":"","ref":"ExJack.Native.html#send_frames/2","title":"ExJack.Native.send_frames/2","type":"function"},{"doc":"","ref":"ExJack.Native.html#start/1","title":"ExJack.Native.start/1","type":"function"},{"doc":"","ref":"ExJack.Native.html#stop/1","title":"ExJack.Native.stop/1","type":"function"},{"doc":"","ref":"ExJack.Native.html#t:options_t/0","title":"ExJack.Native.options_t/0","type":"type"},{"doc":"A GenServer module that interfaces with JACK audio API I/O. There are two methods for outputting sound to JACK: Calling send_frames/1 Setting an output function using set_output_func/1 , which JACK calls every time it wants frames. At the moment, there is only one method of retrieving input data, which is to set an input callback using set_input_func/1 . Latency will obviously vary and if you have a busy machine, expect xruns. xruns, which is shorthand for overruns and underruns, occur when you either send too many frames or not enough frames. If the CPU is busy doing some other work and neglects to send frames to the soundcard, the soundcard buffer runs out of frames to play. An underrun will then occur. You could send too many frames to the soundcard. If you send more than its buffers can hold, the data will be lost. This is an overrun.","ref":"ExJack.Server.html","title":"ExJack.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExJack.Server.html#child_spec/1","title":"ExJack.Server.child_spec/1","type":"function"},{"doc":"Sends a list of frames for JACK to play during its next cycle.","ref":"ExJack.Server.html#send_frames/1","title":"ExJack.Server.send_frames/1","type":"function"},{"doc":"Set the callback function that will receive input data from JACK each cycle. The output of the function is currently not used for anything.","ref":"ExJack.Server.html#set_input_func/1","title":"ExJack.Server.set_input_func/1","type":"function"},{"doc":"Set the callback function that JACK will call when it requests more frames.","ref":"ExJack.Server.html#set_output_func/1","title":"ExJack.Server.set_output_func/1","type":"function"},{"doc":"Start the server. JACK NIF will start a thread that runs the JACK client. It will auto-connect to two standard channels which you can modify through JACK. Parameters name: Used to name the JACK node (suffixed with :in and :out ) e.g. If you pass %{name: &quot;HelloWorld&quot;} , you can interface with this connection within JACK through HelloWorld:in and HelloWorld:out .","ref":"ExJack.Server.html#start_link/1","title":"ExJack.Server.start_link/1","type":"function"},{"doc":"","ref":"ExJack.Server.html#t:frames_t/0","title":"ExJack.Server.frames_t/0","type":"type"},{"doc":"","ref":"ExJack.Server.html#t:input_func_t/0","title":"ExJack.Server.input_func_t/0","type":"type"},{"doc":"","ref":"ExJack.Server.html#t:options_t/0","title":"ExJack.Server.options_t/0","type":"type"},{"doc":"","ref":"ExJack.Server.html#t:output_func_t/0","title":"ExJack.Server.output_func_t/0","type":"type"},{"doc":"","ref":"ExJack.Server.html#t:t/0","title":"ExJack.Server.t/0","type":"type"},{"doc":"JACK audio interface for Elixir using Rustler-based NIF. The purpose of this library is to provide an audio outlet for Elixir through all platforms. However, if you're on Linux, and don't need JACK outright, it's probably preferable to use ExAlsa and interface with ALSA directly.","ref":"readme.html","title":"ExJack","type":"extras"},{"doc":"Tested with : JACK 2 ( see https :// github . com / RustAudio / rust - jack ) Elixir 1.12 Rust 1.56 . 1","ref":"readme.html#requirements","title":"ExJack - Requirements","type":"extras"},{"doc":"OSX brew install jack brew services start jack mix test It may help to view what's going with JACK using a GUI like https://qjackctl.sourceforge.io/ . If you want to capture sound this is simplest way to connect until an API is added to assist with this.","ref":"readme.html#set-up","title":"ExJack - Set-up","type":"extras"},{"doc":"This is an example of piping your capture to output, be wary of feedback. You have to explicity connect your capture with &quot;ExJackDemo:in&quot;, if you're unsure how to do this, install QJackCTL. $ iex - s mix &gt; ExJack.Server . start_link ( %{ name : &quot;ExJackDemo&quot; } ) &gt; ExJack.Server . set_input_func ( fn frames -&gt; ExJack.Server . send_frames ( frames ) end )","ref":"readme.html#usage","title":"ExJack - Usage","type":"extras"},{"doc":"Road to stable version 1 The first three are necessary to make this library useable beyond hobby projects. [ ] Better support for expected frames per cycle from JACK [ ] Handle variable channels with definable sources [ ] Handle JACK notifications [ ] Handling for cases that drop the JACK client such as underruns. [ ] Additional tests in Elixir [ ] Additional tests in Rust [ ] MCU demo [ ] Improve documentation with additional examples [ ] Autocorrection for xruns","ref":"readme.html#todo","title":"ExJack - TODO","type":"extras"},{"doc":"Releases Taken from https://hexdocs.pm/rustler_precompiled/precompilation_guide.html#the-release-flow release a new tag push the code to your repository with the new tag : git push origin main -- tags wait for all NIFs to be built run the mix rustler_precompiled . download task ( with the flag -- all ) release the package to Hex . pm .","ref":"readme.html#dev","title":"ExJack - Dev","type":"extras"},{"doc":"MIT License Copyright (c) 2022 Adrian Fraiha Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Enhancements First public release","ref":"changelog.html#v0-1-0-2022-04-03","title":"CHANGELOG - v0.1.0 (2022-04-03)","type":"extras"}]